#!/bin/sh
set -e
if [ -e /etc/alpine-release ]; then
    distro="alpine"
fi
echo "Installing basic packages"
case $distro in
    "alpine")
        sudo apk update
        sudo apk add \
            bash \
            coreutils \
            git \
            less \
            python3 \
            rxvt-unicode-terminfo \
            tmux \
            vim \
            zsh \
            zsh-vcs
        ;;
    *)
        echo "unknown distribution “${distro}”"
        exit 1
        ;;
esac
echo "Setting up powerline"
fc-cache -vf || true
pip3 install --user powerline-status
